// Generated by dts-bundle-generator v8.0.1

import { Placement } from '@floating-ui/react';
import React from 'react';
import { CSSProperties, MutableRefObject, RefObject } from 'react';

export type SelectionDetails = {
	baseNode?: Node | null;
	extentNode?: Node | null;
	range?: Range;
	selectedHtml?: string;
	selectedText?: string;
} | null | undefined;
export type TargetSelector = string | {
	current: HTMLElement;
} | MutableRefObject<undefined> | RefObject<HTMLDivElement>;
export type TargetElements = NodeList | (HTMLElement | HTMLDivElement | null | undefined)[] | null;
export type HMClientRect = {
	top: number;
	left: number;
	width: number;
	height: number;
};
export type SuccessCallback = () => void;
export type ErrorCallback = (error: any) => void;
export type SetClipboard = (text: string | undefined, onSuccess?: SuccessCallback, onError?: ErrorCallback) => Promise<boolean> | false;
export type SetMenuOpen = HMClientRect | false | null;
export interface MenuArgs {
	selectedHtml?: string | undefined;
	selectedText?: string | undefined;
	setMenuOpen: React.Dispatch<SetMenuOpen>;
	setClipboard: SetClipboard;
}
export type MainArgs = {
	target: TargetSelector;
	menu: (props: MenuArgs) => React.ReactNode;
	styles?: CSSProperties;
	offset?: number;
	allowedPlacements: Array<Placement>;
	zIndex?: number;
};
export declare function HighlightMenu({ target, menu, offset, styles, allowedPlacements, zIndex, ...props }: MainArgs): import("react/jsx-runtime").JSX.Element;
export interface MenuButtonProps {
	onClick?: () => void;
	disabled?: boolean;
	children?: React.ReactNode;
	style?: React.CSSProperties;
	svg?: React.ReactNode;
	icon?: string;
	title?: string;
}
export declare const MenuButton: React.FC<MenuButtonProps>;
export declare function useGetSelectionDetails(target: TargetSelector): SelectionDetails;
export declare const getPopoverCoordinates: (range: Range | undefined) => HMClientRect | null;
export declare const setClipboard: SetClipboard;
export declare function resolveTargets(target: TargetSelector): TargetElements;
export declare function getSelectionDetails(): SelectionDetails;
export declare function isSelectionWithinTarget(targets: TargetElements, selection: SelectionDetails): boolean;

export as namespace ReactHighlightMenu;

export {};
